
/* Exemple de client pour les sockets, le client
 * ouvre le socket et y envoie tout ce qu'il lit
 * sur l'entree standart.
 *
 * compiler avec la commande 
 *
 *  sur les pc linux
 *   cc socket_clt.c -o socket_clt
 *  sur les sun:
 *   cc socket_clt.c -o socket_clt -lsocket -lnsl
 *
 * utilisation
 *    socket_clt adresse_serveur numero_de_port
 *
 * notes:
 *       L'adresse du serveur doit etre un numero IP
 *       exemple 129.194.79.77  En principe toutes
 *       les machines du CUI possedent une petite
 *       etiquette orange avec leur numero IP  marque 
 *       dessus.
 *
 *       Le numero de port doit etre le meme que celui
 *       utilise pour le serveur.
 *
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>



void main(int argc, char** argv )
{ 
  int    sockfd,newsockfd,clilen,chilpid,ok,nleft,nbwriten;
  char c;
  struct sockaddr_in cli_addr,serv_addr;

  if (argc!=3) {printf ("usage  socket_clt adresse_serveur numero_de_por\n");exit(0);}
 
 
  /*
   *  partie client 
   */
  printf ("client starting\n");  

  /* initialise la structure de donnee */
  bzero((char*) &serv_addr, sizeof(serv_addr));
  serv_addr.sin_family       = AF_INET;
  serv_addr.sin_addr.s_addr  = inet_addr(argv[1]);
  serv_addr.sin_port         = htons(atoi(argv[2]));
  
  /* ouvre le socket */
  if ((sockfd=socket(AF_INET,SOCK_STREAM,0))<0)
    {printf("socket error\n");exit(0);}
  
  /* effectue la connection */
  if (connect(sockfd,(struct sockaddr*)&serv_addr,sizeof(serv_addr))<0)
    {printf("socket error\n");exit(0);}
    
  
  /* repete dans le socket tout ce qu'il entend */
  while (1) {c=getchar();write (sockfd,&c,1);}
  
  
  /*  attention il s'agit d'une boucle infinie 
   *  le socket n'est jamais ferme !
   */
}
